//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <StrUtils.hpp>
#pragma hdrstop

#include "untMain.h"
#include "NPIGFAPI.h"
#include "untPrintInformation.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmLDMain *frmLDMain;
//---------------------------------------------------------------------------

// v^\̐
// Create Printer Infomation Structure
PPRTSetInfo prtSetInfo = (PPRTSetInfo)malloc(sizeof(PRTSetInfo));

// foCXReLXg쐬
// Create Device Context
void CreateHDC(HDC *o_HDC, HBITMAP *o_HBitmap, float i_Width, float i_Height)
{
	LPDWORD lpPixel;
	HBRUSH hBrush;
	RECT lprc[1];
	BITMAPINFO bmpInfo;

	bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biWidth = i_Width;
	bmpInfo.bmiHeader.biHeight = i_Height;
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biBitCount = 24;
	bmpInfo.bmiHeader.biCompression = BI_RGB;

	// foCXReLXg쐬
	// Create Compatible Device Context
	*o_HBitmap = CreateDIBSection(NULL, &bmpInfo, DIB_RGB_COLORS, (void**)&lpPixel, NULL, 0);
	*o_HDC = CreateCompatibleDC(NULL);
	SelectObject(*o_HDC, *o_HBitmap);

	// ̈ݒ
	// Setting Size
	lprc[0].left = 0;
	lprc[0].top = 0;
	lprc[0].right = i_Width;
	lprc[0].bottom = i_Height;

	// `(lp`hԂ F:)
	// Draw White Fill Rect
	hBrush = CreateSolidBrush(RGB(255, 255, 255));
	SelectObject(*o_HDC, hBrush);
	FillRect(*o_HDC, &lprc[0], hBrush);

	SelectObject(*o_HDC, *o_HBitmap);

	DeleteObject(hBrush);
	hBrush = NULL;
}

// Chϊ
// Convert Wide String
wchar_t* StrToWChar(const char* i_dat)
{
size_t len;
wchar_t *wc;
	setlocale(LC_ALL, "Japanese");
	len = _mbstrlen(i_dat) + 1;
	wc = (wchar_t*)malloc(len * sizeof(wchar_t));
	wmemset(wc, 0x00, len);
	mbstowcs(wc, i_dat, len);
	setlocale(LC_ALL, "");
	return wc;
}

__fastcall TfrmLDMain::TfrmLDMain(TComponent* Owner) : TForm(Owner)
{
	// NPIGF.dll֐AhX擾
	// NPIGF.dll Get Function Addresss
	int res = LoadNPIGF();
	if(res < 0)
	{
		MessageBox(NULL, L"DLL Road Error", L"DLL Error", MB_OK);
	}

	// ݒt@C쐬(NPIEasyPrint.inf)
	// Create NPIEasyPrint.inf file
	_npiapi.NPrinterInitEpW(NULL);

	// v^̎擾
	// Get Printer Names
	GetPrinters();

	// XMLt@CpX\
	// Show XML File Path
	Edit5->Text = ExtractFilePath(Application->ExeName) + "Format1.xml";
}

void __fastcall TfrmLDMain::Close(TObject *Sender, TCloseAction &Action)
{
	free(prtSetInfo);
}

void TfrmLDMain::GetPrinters()
{
TStringDynArray array;
PWCHAR prtlist = NULL;
DWORD size = 0;
int nRet, i;

	// v^ꗗNA
	// Printer List Clear
	ComboBox1->Items->Clear();
	ComboBox2->Items->Clear();
	ComboBox3->Items->Clear();

	// v^ꗗi[TCY擾
	// Get Printer List Size
	nRet = _npiapi.NEnumPrinters(NULL, &size);

	if(nRet < 0 || size <= 0)
	{
		return;
	}

	prtlist = (PWCHAR) malloc ((size+1) * sizeof(WCHAR));
	wmemset(prtlist, 0x00, size+1);

	// v^擾
	// Get Printer Name List
	_npiapi.NEnumPrinters(prtlist, &size);

	// v^ꗗݒ
	// Create Printer Name List
	array = SplitString(prtlist, L",");
	for (i = 0; i < array.Length; i++)
	{
		ComboBox1->Items->Add(array[i].c_str());
		ComboBox2->Items->Add(array[i].c_str());
		ComboBox3->Items->Add(array[i].c_str());
	}

	// Is擪ɂ
	// Select the first of the combo box
	ComboBox1->ItemIndex = 0;
	ComboBox2->ItemIndex = 0;
	ComboBox3->ItemIndex = 0;

    free(prtlist);
}

// Ch쐬
// Create Wide String
PWCHAR TfrmLDMain::GetPWCHAR(UnicodeString Text)
{
size_t size;
PWCHAR wch = NULL;

	if(Text.Length() > 0)
	{
		size = _mbstrlen(AnsiString(Text).c_str()) + 1;
		wch = (PWCHAR)malloc(size*sizeof(WCHAR));
		memcpy(wch, StrToWChar(AnsiString(Text).c_str()), size*sizeof(WCHAR));
	}

	return wch;
}

// oCg쐬
// Create Byte
PBYTE TfrmLDMain::GetPBYTE(UnicodeString HEXText, PINT datSize)
{
int len, i;
PBYTE pBuffer = NULL;
PCHAR text = AnsiString(HEXText).c_str();
unsigned int x;

	*datSize = 0;
	if(HEXText.Length() > 0)
	{
		// oCgTCYݒ
		// Setting Byte Size
		len = strlen(text);
		if (len % 2 != 0)
		{
			*datSize = len / 2 + 1 + 2;
		}
		else
		{
			*datSize = len / 2 + 2;
		}

		pBuffer = (PBYTE)malloc(*datSize*sizeof(BYTE));
		memset(pBuffer, 0x00, *datSize);

		// oCgݒ
		// Setting Byte
		for(i=0; i<len; i+=2)
		{
			sscanf((char *)(text + i), "%02x", &x);
			pBuffer[i/2] = x;
		}
	}

	return pBuffer;
}


//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button1Click(TObject *Sender)
{
size_t size;
int res;
TFileTypeItem *typeitem;
string msg = "", title = "";

	// XMLt@CI_CAO\
	// Show Select XML Dialog
	FileOpenDialog1->FileTypes->Clear();
	typeitem = FileOpenDialog1->FileTypes->Add();
	if(FileOpenDialog1->Execute())
	{
		// tH[}bgXMLǂݍ
		// Read Format XML
		res = _npiapi.NReadInfoEpW(StrToWChar(((AnsiString)FileOpenDialog1->FileName).c_str()));

		// ʕ\
		// Show Result
		title.append("Read XML");
		if(res == 0)
		{
			msg.append("Read Format Success\r\n");
			Label19->Caption = FileOpenDialog1->FileName;
			Label24->Caption = FileOpenDialog1->FileName;
			Label26->Caption = FileOpenDialog1->FileName;
		}
		else
		{
			msg.append("Read Format Error\r\n");
		}
		msg.append("Result Code:");
		msg.append(AnsiString(IntToStr(res)).c_str());

		MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button2Click(TObject *Sender)
{
int res;
string msg = "", title = "";

	// XMLt@C݃_CAO\
	// Show Save Dialog
	if(SaveDialog1->Execute())
	{
		// XMLo
		// Save XML
		res = _npiapi.NSaveDataEpW(0, StrToWChar(((AnsiString)SaveDialog1->FileName).c_str()));

		// ʕ\
		// Show Result
		title.append("Output XML");
		if(res == 0)
		{
			msg.append("Create File Success\r\n");
			Label22->Caption = SaveDialog1->FileName;
		}
		else
		{
			msg.append("Create File Error\r\n");
		}
		msg.append("Result Code:");
		msg.append(AnsiString(IntToStr(res)).c_str());

		MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button3Click(TObject *Sender)
{
int res;
string msg = "", title = "";

	// v^ݒ
	// Get Printer Name
	prtSetInfo->prtName = GetPWCHAR(ComboBox1->Text);

	// 󎚁E`ݒ
	// Setting Print Infomation
	prtSetInfo->border = StrToInt(Edit12->Text);
	prtSetInfo->makeSelect = StrToInt(Edit14->Text);
	prtSetInfo->copyCnt = StrToInt(Edit15->Text);
	prtSetInfo->printCnt = StrToInt(Edit1->Text);
	prtSetInfo->Interval = StrToInt(Edit2->Text);

	// R|[lg󎚁E`
	// Component Print / Draw Component
	res = _npiapi.NImagePrintEpW(prtSetInfo);

	// ʕ\
	// Show Result
	title.append("Component Print / Draw Component");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());

	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(prtSetInfo->prtName != NULL)
	{
		free(prtSetInfo->prtName);
		prtSetInfo->prtName = NULL;
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button4Click(TObject *Sender)
{
PWCHAR name = NULL;
PWCHAR data = NULL;
int res;
string msg = "", title = "";

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);

	// f[^ݒ
	// Get Component Data
	data = GetPWCHAR(Edit4->Text);

	// eLXgR|[lgݒ
	// Setting Text Component
	res = _npiapi.NSetTextEpW(NULL, name, data);

	// ʕ\
	// Show Result
	title.append("Setting Text Component");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
	if(data != NULL)
	{
		free(data);
	}

}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button5Click(TObject *Sender)
{
PWCHAR name = NULL;
PBYTE pBuffer = NULL;
int datSize = 0;
int res;
string msg = "", title = "";

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);

	// f[^ݒ
	// Get Byte Data
	pBuffer = GetPBYTE(Edit4->Text, &datSize);

	// o[R[hR|[lgݒ
	// Setting Barcode Component
	res = _npiapi.NSetBarcodeEpW(NULL, name, pBuffer, datSize);

	// ʕ\
	// Show Result
	title.append("Setting Barcode Component");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
	if(pBuffer != NULL)
	{
		free(pBuffer);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button12Click(TObject *Sender)
{
TFileTypeItem *typeitem;

	// 摜I_CAO\
	// Show Slect Image Dialog
	Image1->Picture = NULL;
	FileOpenDialog1->FileTypes->Clear();
	typeitem = FileOpenDialog1->FileTypes->Add();
	typeitem->DisplayName = "Image";
	typeitem->FileMask = "*.bmp";
	if(FileOpenDialog1->Execute())
	{
		Image1->Picture->LoadFromFile(FileOpenDialog1->FileName);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button6Click(TObject *Sender)
{
PWCHAR name = NULL;
int res;
string msg = "", title = "";

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);

	// 摜ݒ
	// Setting Image Component
	res = _npiapi.NSetImageEpW(NULL, name, Image1->Canvas->Handle, 110, 110);

	// ʕ\
	// Show Result
	title.append("Setting Image Component");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button7Click(TObject *Sender)
{
PWCHAR name = NULL;
PWCHAR data = NULL;
int res;
string msg = "", title = "";
char *mbs;
wstring wstr;

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);

	// f[^ݒ
	// Get Component Data
	data = GetPWCHAR(Edit4->Text);

	wstr.clear();
	if(data == NULL)
	{
		wstr.append(L"");
	}
	else
	{
		wstr.append(data);
	}

	mbs = (char*)malloc(wstr.length() * MB_CUR_MAX + 1);
	wcstombs(mbs, wstr.c_str(), wstr.length() * MB_CUR_MAX + 1);

	// Zݒ
	// Setting Cell Component
	res = _npiapi.NSetCellEpW(NULL, name, StrToInt(Edit10->Text),
			StrToInt(Edit11->Text), mbs);

	// ʕ\
	// Show Result
	title.append("Setting Cell Component");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
	if(data != NULL)
	{
		free(data);
	}
	if(mbs != NULL)
	{
		free(mbs);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button8Click(TObject *Sender)
{
PWCHAR name = NULL;
PWCHAR o_dat = NULL;
DWORD o_size = 0;
int res;
string msg = "", title = "";
PCHAR data, mbs;
wstring wstr;

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);


	// KvTCY擾
	// Get Text Data Need Size
	res = _npiapi.NGetTextEpW(NULL, name, NULL, &o_size);

	title.append("Get Text Component Data");
	if(res == 0)
	{
		// eLXgR|[lgf[^擾
		// Get Text Component Data
		o_dat = (PWCHAR)malloc((o_size+1)*sizeof(WCHAR));
		memset(o_dat, 0x00, (o_size+1));
		res = _npiapi.NGetTextEpW(NULL, name, o_dat, &o_size);

		wstr.clear();
		wstr.append(o_dat);
		mbs = (PCHAR)malloc(wstr.length() * MB_CUR_MAX + 1);
		wcstombs(mbs, wstr.c_str(), wstr.length() * MB_CUR_MAX + 1);

		msg.append("Data:");
		msg.append(mbs);
		msg.append("\r\n");

		free(o_dat);
	}

	// ʕ\
	// Show Result
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button9Click(TObject *Sender)
{
PWCHAR name = NULL;
PBYTE o_dat = NULL;
DWORD o_size = 0;
int res;
string msg = "", title = "";

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);

	// KvTCY擾
	// Get Barcode Data Need Size
	res = _npiapi.NGetBarcodeEpW(NULL, name, NULL, &o_size);

	title.append("Get Barcode Component Data");
	if(res == 0)
	{
		// o[R[hR|[lgf[^擾
		// Get Barcode Component Data
		o_dat = (PBYTE)malloc((o_size+1)*sizeof(BYTE));
		memset(o_dat, 0x00, (o_size+1)*sizeof(BYTE));
		res = _npiapi.NGetBarcodeEpW(NULL, name, o_dat, &o_size);

		msg.append("Data:");
		msg.append((PCHAR)o_dat);
		msg.append("\r\n");
		free(o_dat);
	}

	// ʕ\
	// Show Result
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button10Click(TObject *Sender)
{
PWCHAR name = NULL;
int res;
DWORD o_w = 0;
DWORD o_h = 0;
HDC hdc = NULL;
HBITMAP hBitmap = NULL;
string msg = "", title = "";

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);

	// KvTCY擾
	// Get Image Data Need Size
	res = _npiapi.NGetImageEpW(NULL, name, NULL, &o_w, &o_h);

	title.append("Get Image Component Data");
	if(res == 0)
	{
		// C[Wi[foCXReLXg쐬
		// Create Device Context
		CreateHDC(&hdc, &hBitmap, o_w, o_h);

		// C[WR|[lgf[^擾
		// Get Image Component Data
		res = _npiapi.NGetImageEpW(NULL, name, hdc, &o_w, &o_h);

		Image2->Picture = NULL;
		BitBlt(Image2->Canvas->Handle,
			0, 0,
			o_w, o_h,
			hdc,
			0, 0,
			SRCCOPY);
	}

	// ʕ\
	// Show Result
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
	DeleteDC(hdc);
	DeleteObject(hBitmap);
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button11Click(TObject *Sender)
{
PWCHAR name = NULL;
PBYTE o_dat = NULL;
INT o_size = 0;
int res;
string msg = "", title = "";

	// R|[lgݒ
	// Get Component Name
	name = GetPWCHAR(Edit3->Text);

	// KvTCY擾
	// Get Cell Data Need Size
	res = _npiapi.NGetCellEpW(NULL, name, StrToInt(Edit10->Text),
		StrToInt(Edit11->Text), NULL, &o_size);

	title.append("Get Cell Component Data");
	if(res == 0)
	{
		// ZR|[lgf[^擾
		// Get Cell Component Data
		o_dat = (PBYTE)malloc((o_size + 1)*sizeof(BYTE));
		memset(o_dat, 0x00, (o_size + 1)*sizeof(BYTE));
		res = _npiapi.NGetCellEpW(NULL, name, StrToInt(Edit10->Text),
			StrToInt(Edit11->Text), (PCHAR)o_dat, &o_size);

		msg.append("Data:");
		msg.append((PCHAR)o_dat);
		msg.append("\r\n");

		free(o_dat);
		o_dat = NULL;
	}

	// ʕ\
	// Show Result
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button16Click(TObject *Sender)
{
PWCHAR name = NULL;
PWCHAR dat = NULL;
DWORD size = 0;
int res;
string msg = "", title = "";

	// v^ݒ
	// Get Printer Name
	name = GetPWCHAR(ComboBox1->Text);

	// Mf[^ݒ
	// Get Send Data
	dat = GetPWCHAR(Edit16->Text);

	// Mf[^
	// Send Data Print
	size = _mbstrlen(AnsiString(Edit16->Text).c_str());
	res = _npiapi.NPrintEpW(name, false, dat, size, NULL);

	// ʕ\
	// Show Result
	title.append("Print");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());

	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
	if(dat != NULL)
	{
		free(dat);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button13Click(TObject *Sender)
{
PWCHAR name = NULL;
int res;
string msg = "", title = "";

	// v^ݒ
	// Get Printer Name
	name = GetPWCHAR(ComboBox3->Text);

	// v^
	// Start Printer Initialize Thread
	res = _npiapi.NPrinterInitEp(AnsiString(ComboBox3->Text).c_str());

	// ʕ\
	// Show Result
	title.append("Printer Initialize");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());

	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button14Click(TObject *Sender)
{
PVOID o_st = NULL;
DWORD o_size = 0;
PWCHAR name = NULL;
int res = 0;
string msg = "", title = "";
char cw[2];

	// v^ݒ
	// Get Printer Name
	name = GetPWCHAR(ComboBox3->Text);

	// KvTCY擾
	// Get Status Data Need Size
	res = _npiapi.NGetStEpW(name, NULL, &o_size);

	title.append("Get Printer Status");
	if(res == 0)
	{
		// v^Xe[^X擾
		// Get Printer Status
		o_st = (PBYTE)malloc(o_size*sizeof(BYTE));
		memset(o_st, 0x00, o_size*sizeof(BYTE));
		res = _npiapi.NGetStEpW(name, o_st, &o_size);

		if(res == 0)
		{
			msg.append("Status ");

			// Xe[^XG[
			// Printer Status Check
			if((*(PBYTE)o_st & 0xFF) == 0)
			{
				msg.append("Normal:");
			}
			else
			{
				msg.append("Error:");
			}
            msg.append("0x");
			sprintf(cw, "%02x", *(PBYTE)o_st);
			msg.append(cw);
			msg.append("\r\n");

		}
		free(o_st);
	}
	// ʕ\
	// Show Result
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button15Click(TObject *Sender)
{
BYTE i_id = 0x00;
PVOID o_dat = NULL;
DWORD o_size = 0;
PWCHAR name = NULL;
int res, len, col;
string msg = "", title = "";
PCHAR data;
PBYTE dat;
char cw[2];

	// v^ݒ
	// Get Printer Name
	name = GetPWCHAR(ComboBox3->Text);

	// gIDݒ
	// Get Extended information ID
	if(Edit13->Text.Length() > 0)
	{
		i_id = StrToInt(Edit13->Text);
	}

	// KvTCY擾
	// Get Extended information Data Need Size
	res = _npiapi.NGetInfoEpW(name, i_id, NULL, &o_size);

	if(res == 0)
	{
		// v^g擾
		// Get Printer Extended information
		o_dat = (PBYTE)malloc(o_size*sizeof(BYTE));
		memset(o_dat, 0x00, o_size*sizeof(BYTE));
		res = _npiapi.NGetInfoEpW(name, i_id, o_dat, &o_size);

		msg.append("Extended Info:\r\n");
		msg.append("+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F\r\n");
		msg.append("------------------------------------------------------------\r\n");

		col = 0;
		dat = (PBYTE)o_dat;
		for(len = 0; len < o_size; len++)
		{
			 sprintf(cw, "%02x ", *((PBYTE)o_dat+len));
			 msg.append(cw);

			 col++;
			 if(col == 16)
			 {
				 msg.append("\r\n");
                 col = 0;
             }
		}

		if(col != 0)
		{
			while(col < 16)
			{
				msg.append("00 ");
				col++;
			}
            msg.append("\r\n");
		}

		data = (PCHAR)o_dat;
		msg.append("String Convert:");
		msg.append(data);
		msg.append("\r\n");

		free(o_dat);
	}
	// ʕ\
	// Show Result
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	Label13->Caption = msg.c_str();

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

// Xe[^XĎR[obN֐
// Function Printer Status Call Back
static void _stdcall fncCallBack(PVOID o_bst, PVOID o_ast)
{
string res = "";
PDWORD bst = NULL;
PDWORD ast = NULL;
char cw[2];

	// OlXe[^Xi[GA擾
	// Get Before Printer Status
	bst = (PDWORD)o_bst;

	res.append("Before Status ");
	if((*(PBYTE)bst & 0xFF) == 0)
	{
		res.append("Normal:");
	}
	else
	{
		res.append("Error:");
	}
	res.append("0x");
	sprintf(cw, "%02x", *(PBYTE)bst);
	res.append(cw);
	res.append("\r\n");

	// lXe[^Xi[GA擾
	// Get Current Printer Status
	ast = (PDWORD)o_ast;

	res.append("Current Status ");
	if((*(PBYTE)ast & 0xFF) == 0)
	{
		res.append("Normal:");
	}
	else
	{
		res.append("Error:");
	}
	res.append("0x");
	sprintf(cw, "%02x", *(PBYTE)ast);
	res.append(cw);
	res.append("\r\n");

	// ʕ\
	// Show Result
	MessageBox(NULL, StrToWChar(res.c_str()),  L"Printer Status", MB_OK);
}


void __fastcall TfrmLDMain::Button17Click(TObject *Sender)
{
PWCHAR name = NULL;
int res;
string msg = "", title = "";

	// v^ݒ
	// Get Printer Name
	name = GetPWCHAR(ComboBox3->Text);

	// v^Xe[^XĎ
	// Start Printer Status On Change Thread
	res = _npiapi.NStartOnChangeStW(name, fncCallBack);

	// ʕ\
	// Show Result
	title.append("Start Printer Status On Change");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());

	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(name != NULL)
	{
		free(name);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button18Click(TObject *Sender)
{
int res;
string msg = "", title = "";

	// v^Xe[^XĎ~
	// Stop Printer Status On Change Thread
	res = _npiapi.NEndOnChangeSt();

	// ʕ\
	// Show Result
	title.append("Stop Printer Status On Change");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);
}

//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button19Click(TObject *Sender)
{
PVOID o_st = NULL;
DWORD o_size = 0;
int res;
string msg = "", title = "";
char cw[2];

	// KvTCY擾
	// Get Status Data Need Size
	res = _npiapi.NGetStEpW_DX(NULL, &o_size);

	title.append("Get Printer Status");
	if(res == 0)
	{
		// v^Xe[^X擾
		// Get Printer Status
		o_st = (PBYTE)malloc(o_size*sizeof(BYTE));
		memset(o_st, 0x00, o_size*sizeof(BYTE));
		res = _npiapi.NGetStEpW_DX(o_st, &o_size);

		if(res == 0)
		{
			msg.append("Status ");

			// Xe[^XG[
			// Printer Status Check
			if((*(PBYTE)o_st & 0xFF) == 0)
			{
				msg.append("Normal:");
			}
			else
			{
				msg.append("Error:");
			}
            msg.append("0x");
			sprintf(cw, "%02x", *(PBYTE)o_st);
			msg.append(cw);
			msg.append("\r\n");
		}
		free(o_st);
	}
	// ʕ\
	// Show Result
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());
	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button21Click(TObject *Sender)
{
int res, datSize = 0;
PWCHAR name = NULL;
PWCHAR filePath = NULL;
PVOID o_st = NULL;
DWORD o_size = 0;
string str = "";
PWCHAR cmpname1 = NULL, cmpname2 = NULL;
PWCHAR data = NULL;
PBYTE pBuffer = NULL;
char cw[2];

	// v^ݒ
	// Get Printer Name
	name = GetPWCHAR(ComboBox2->Text);

	// v^
	// Printer Initialize
	res = _npiapi.NPrinterInitEpW(name);

	str.append("1 NPrinterInitEpW    Result Code:");
	str.append(AnsiString(IntToStr(res)).c_str());
	str.append("\r\n\r\n");

	// t@CpX擾
	// Get Format File Path
	filePath = GetPWCHAR(Edit5->Text);


	// tH[}bgXMLǂݍ
	// Read XML Format
	res = _npiapi.NReadInfoEpW(filePath);

	if(res == 0)
	{
		Label19->Caption = Edit5->Text;
		Label24->Caption = Edit5->Text;
		Label26->Caption = Edit5->Text;
	}

	str.append("2 NReadInfoEpW    Result Code:");
	str.append(AnsiString(IntToStr(res)).c_str());
	str.append("\r\n\r\n");

	// KvTCY擾
	// Get Status Data Need Size
	res = _npiapi.NGetStEpW(name, NULL, &o_size);

	if(res == 0)
	{
		// v^Xe[^X擾
		// Get Printer Status
		o_st = (PBYTE)malloc(o_size*sizeof(BYTE));
		memset(o_st, 0x00, o_size*sizeof(BYTE));
		res = _npiapi.NGetStEpW(name, o_st, &o_size);

		str.append("3 NGetStEpW         Result Code:");
		str.append(AnsiString(IntToStr(res)).c_str());
		str.append("\r\n");

		if(res == 0)
		{
			str.append("Status ");

			// Xe[^XG[
			// Printer Status Check
			if((*(PBYTE)o_st & 0xFF) == 0)
			{
				str.append("Normal:");
			}
			else
			{
				str.append("Error:");
			}
			str.append("0x");
			sprintf(cw, "%02x", *(PBYTE)o_st);
			str.append(cw);
			str.append("\r\n");
		}
		str.append("\r\n");
		free(o_st);
	}

	// eLXgR|[lgݒ
	// Get Text Component Name
	cmpname1 = GetPWCHAR(Edit6->Text);

	// f[^ݒ
	// Get Text Component Data
	data = GetPWCHAR(Edit7->Text);

	// eLXgR|[lgݒ
	// Setting Text Component
	res = _npiapi.NSetTextEpW(NULL, cmpname1, data);

	str.append("4 NSetTextEpW       Result Code:");
	str.append(AnsiString(IntToStr(res)).c_str());
	str.append("\r\n\r\n");

	// o[R[hR|[lgݒ
	// Get Barcode Component Name
	cmpname2 = GetPWCHAR(Edit8->Text);

	// o[R[hf[^ݒ
	// Get Barcode Component Data
	pBuffer = GetPBYTE(Edit9->Text, &datSize);

	// o[R[hR|[lgݒ
	// Setting Barcode Component
	res = _npiapi.NSetBarcodeEpW(NULL, cmpname2, pBuffer, datSize);

	str.append("5 NSetBarcodeEpW Result Code:");
	str.append(AnsiString(IntToStr(res)).c_str());
	str.append("\r\n\r\n");

	// v^ݒ
	// Get Printer Name
	prtSetInfo->prtName = GetPWCHAR(ComboBox2->Text);

	// 󎚁E`ݒ
	// Setting Print Infomation
	prtSetInfo->border = 0;
	prtSetInfo->makeSelect = 0;
	prtSetInfo->copyCnt = 1;
	prtSetInfo->printCnt = 1;
	prtSetInfo->Interval = 0;

	// R|[lg󎚁E`
	// Component Print / Draw Component
	res = _npiapi.NImagePrintEpW(prtSetInfo);

	str.append("6 NImagePrintEpW Result Code:");
	str.append(AnsiString(IntToStr(res)).c_str());
	str.append("\r\n");

	// ʕ\
	// Show Result
	MessageBox(NULL, StrToWChar(str.c_str()), L"Result", MB_OK);

	if(filePath != NULL)
	{
		free(filePath);
	}
	if(prtSetInfo->prtName != NULL)
	{
		free(prtSetInfo->prtName);
		prtSetInfo->prtName = NULL;
	}
	if(name != NULL)
	{
		free(name);
	}
	if(cmpname1 != NULL)
	{
		free(cmpname1);
	}
	if(cmpname2 != NULL)
	{
		free(cmpname2);
	}
	if(data != NULL)
	{
		free(data);
	}
	if(pBuffer != NULL)
	{
		free(pBuffer);
	}

}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button20Click(TObject *Sender)
{
int res;
string msg = "", title = "";

	// v^ݒ
	// Get Printer Name
	prtSetInfo->prtName = GetPWCHAR(ComboBox1->Text);

	// 󎚁E`ݒ
	// Setting Print Infomation
	prtSetInfo->border = StrToInt(Edit12->Text);
	prtSetInfo->makeSelect = StrToInt(Edit14->Text);
	prtSetInfo->copyCnt = StrToInt(Edit15->Text);
	prtSetInfo->printCnt = StrToInt(Edit1->Text);
	prtSetInfo->Interval = StrToInt(Edit2->Text);

	// R|[lg󎚁E`
	// Component Print / Draw Component
	res = _npiapi.NImagePrintEp_DX(prtSetInfo);

	// ʕ\
	// Show Result
	title.append("Component Print / Draw Component");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());

	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

//	if(prtSetInfo->prtName != NULL)
//	{
//		free(prtSetInfo->prtName);
//		prtSetInfo->prtName = NULL;
//	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmLDMain::Button22Click(TObject *Sender)
{
PWCHAR dat = NULL;
DWORD size = 0;
int res;
string msg = "", title = "";

	// Mf[^ݒ
	// Get Send Data
	dat = GetPWCHAR(Edit16->Text);

	// Mf[^
	// Send Data Print
	size = _mbstrlen(AnsiString(Edit16->Text).c_str());
	res = _npiapi.NPrintEpW_DX(false, dat, size, NULL);

	// ʕ\
	// Show Result
	title.append("Print");
	msg.append("Result Code:");
	msg.append(AnsiString(IntToStr(res)).c_str());

	MessageBox(NULL, StrToWChar(msg.c_str()), StrToWChar(title.c_str()), MB_OK);

	if(dat != NULL)
	{
		free(dat);
	}
}
//---------------------------------------------------------------------------

